unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, ZConnection, ZDataset, Forms, Controls,
  Graphics, Dialogs, Grids, StdCtrls, Buttons, ExtCtrls,
  BGRAImageTheme, mvMapViewer, MVTYPES,
  BGRAGraphicControl, BGRABitmap, BCTypes, BGRABitmapTypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    BGRAGraphicControl1: TBGRAGraphicControl;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    MapView1: TMapView;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    SpeedButton1: TSpeedButton;
    StringGrid1: TStringGrid;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    procedure BGRAGraphicControl1Redraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MapView1Change(Sender: TObject);
    procedure MapView1ZoomChange(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ZConnection1AfterConnect(Sender: TObject);
    procedure ZConnection1AfterDisconnect(Sender: TObject);
  private
    procedure Laden;
  public
  end;

var
  Form1: TForm1;
  dcon: integer;
  Kartenpunkt: TRealPoint;
  zoomfakt: integer;
  vonLat: Double;
  bisLat: Double;
  vonLon: Double;
  bisLon: Double;
  drehwinkel: integer;
  angle: integer;
  bildflieger: TBGRABitmap;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
 bildflieger.Free;
 ZConnection1.Disconnect;
 CloseAction:=caFree;
end;

procedure TForm1.BGRAGraphicControl1Redraw(Sender: TObject; Bitmap: TBGRABitmap);
begin
  Bitmap.FillTransparent;
  Bitmap.PutImageAngle(Width div 2, Height div 2, bildflieger, angle, TResampleFilter.rfBestQuality, bildflieger.Width div 2, bildflieger.Height div 2);
  if FileExists(ExtractFilePath(ParamStr(0))+'BGRAFlieger.bmp') then
  begin
    DeleteFile(ExtractFilePath(ParamStr(0))+'BGRAFlieger.bmp');
  end;
  Bitmap.SaveToFile(ExtractFilePath(ParamStr(0))+'BGRAFlieger.bmp');
  Image1.Picture.Bitmap.LoadFromFile(ExtractFilePath(ParamStr(0))+'BGRAFlieger.bmp');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 dcon:=0;
 ZConnection1.Connect;
 bildflieger:=TBGRABitmap.Create;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  StringGrid1.RowCount:=2;
  StringGrid1.ColCount:=2;
  StringGrid1.ColWidths[0]:=700;
  StringGrid1.ColWidths[1]:=700;
  StringGrid1.Cells[0, 0]:='Host';
  StringGrid1.Cells[1, 0]:='User';
  StringGrid1.Cells[0, 1]:='';
  StringGrid1.Cells[1, 1]:='';
  zoomfakt:=11;
  ScrollBar1.Position:=zoomfakt;
// Zoomfakt min=3 max=19
  Label1.Caption:=IntToStr(zoomfakt);
  MapView1.Active:=True;
  MapView1.Zoom:=zoomfakt;
  Kartenpunkt.Lat:=49.509;
  Kartenpunkt.Lon:=8.533;
  MapView1.Center:=Kartenpunkt;
  drehwinkel:=0;
  Label8.Caption:=IntToStr(drehwinkel);
  ScrollBar2.Position:=drehwinkel;
  Laden;
StringGrid1.Visible:=False;
MapView1.Visible:=False;
  Image1.Canvas.Pen.Color:=clBlack;
  Image1.Canvas.Pen.Style:=psSolid;
  Image1.Canvas.Pen.Width:=1;
  Image1.Canvas.Brush.Color:=clBlack;
  Image1.Canvas.Brush.Style:=bsSolid;
  Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
//  Image1.Picture.Bitmap.LoadFromFile(ExtractFilePath(ParamStr(0))+'flieger.bmp');
  bildflieger.FillTransparent;
  bildflieger.LoadFromFile(ExtractFilePath(ParamStr(0))+'flieger.bmp');
  angle:=0;
end;

procedure TForm1.MapView1Change(Sender: TObject);
  var XPos: integer;
  var YPos: integer;
begin
  XPos:=756;
  YPos:=0;
  Kartenpunkt:=MapView1.ScreenToLonLat(Point(XPos, YPos));
  bisLat:=Kartenpunkt.Lat;
  XPos:=756;
  YPos:=326;
  Kartenpunkt:=MapView1.ScreenToLonLat(Point(XPos, YPos));
  vonLat:=Kartenpunkt.Lat;
  XPos:=0;
  YPos:=326;
  Kartenpunkt:=MapView1.ScreenToLonLat(Point(XPos, YPos));
  vonLon:=Kartenpunkt.Lon;
  XPos:=1515;
  YPos:=326;
  Kartenpunkt:=MapView1.ScreenToLonLat(Point(XPos, YPos));
  bisLon:=Kartenpunkt.Lon;
// Latitude  Breitengrad horizontal oben kleiner als unten
// Longitude Längengrad vertikal links kleiner als rechts
  Label2.Caption:='von Latitude: '+FloatToStr(vonLat);
  Label3.Caption:='bis Latitude: '+FloatToStr(bisLat);
  Label4.Caption:='von Longitude: '+FloatToStr(vonLon);
  Label5.Caption:='bis Longitude: '+FloatToStr(bisLon);
end;

procedure TForm1.MapView1ZoomChange(Sender: TObject);
  var XPos: integer;
  var YPos: integer;
begin
  XPos:=756;
  YPos:=0;
  Kartenpunkt:=MapView1.ScreenToLonLat(Point(XPos, YPos));
  bisLat:=Kartenpunkt.Lat;
  XPos:=756;
  YPos:=326;
  Kartenpunkt:=MapView1.ScreenToLonLat(Point(XPos, YPos));
  vonLat:=Kartenpunkt.Lat;
  XPos:=0;
  YPos:=326;
  Kartenpunkt:=MapView1.ScreenToLonLat(Point(XPos, YPos));
  vonLon:=Kartenpunkt.Lon;
  XPos:=1515;
  YPos:=326;
  Kartenpunkt:=MapView1.ScreenToLonLat(Point(XPos, YPos));
  bisLon:=Kartenpunkt.Lon;
  Label2.Caption:='von Latitude: '+FloatToStr(vonLat);
  Label3.Caption:='bis Latitude: '+FloatToStr(bisLat);
  Label4.Caption:='von Longitude: '+FloatToStr(vonLon);
  Label5.Caption:='bis Longitude: '+FloatToStr(bisLon);
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  zoomfakt:=ScrollBar1.Position;
  MapView1.Zoom:=zoomfakt;
  Label1.Caption:=IntToStr(zoomfakt);
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  angle:=ScrollBar2.Position;
  Label8.Caption:=IntToStr(angle);
  BGRAGraphicControl1.DiscardBitmap;
end;

procedure TForm1.ZConnection1AfterConnect(Sender: TObject);
begin
  dcon:=1;
end;

procedure TForm1.ZConnection1AfterDisconnect(Sender: TObject);
begin
  dcon:=0;
end;

procedure TForm1.Laden;
  var f1: string;
  var f2: string;
  var z: integer;
begin
  z:=1;
  ZQuery1.SQL.Text:='SELECT * FROM user';
  ZQuery1.Open;
  while not ZQuery1.EOF do
  begin
    f1:=ZQuery1.Fields[0].AsString;
    f2:=ZQuery1.Fields[1].AsString;
    z:=z + 1;
    StringGrid1.RowCount:=z;
    z:=z - 1;
    StringGrid1.Cells[0, z]:=f1;
    StringGrid1.Cells[1, z]:=f2;
    z:=z + 1;
    ZQuery1.Next;
  end;
  ZQuery1.Close;
  if z = 1 then
  begin
    StringGrid1.RowCount:=2;
    StringGrid1.Cells[0, 1]:='';
    StringGrid1.Cells[1, 1]:='';
  end;
end;

end.

